



Src:

```
main.cpp
multiobj.cpp
multiobj.h
```



without LLVM CFI:

```
➜  testspace clang++ main.cpp ./multiobj.cpp -Wl,-rpath,./
➜  testspace clang++ main.cpp ./multiobj.so -Wl,-rpath,./
➜  testspace ./a.out
class1_inso::f_so1()
class1_inso::f_so1()
```





calls inside main.cpp is protected but calls inside DSO are not:

```
➜  testspace clang++ ./multiobj.cpp -flto -fpic -shared -o multiobj.so
➜  testspace clang++ ./main.cpp ./multiobj.so  -fsanitize=cfi -flto  -fvisibility=hidden -fsanitize-cfi-cross-dso -Wl,-rpath,./
➜  testspace ./a.out
class1_inso::f_so1()
class1_inso::f_so1()
```





Then let's protect the calls inside DSO:

```
➜  testspace clang++ ./multiobj.cpp -flto -fsanitize=cfi -fvisibility=hidden -fpic -shared  -omultiobj.so
➜  testspace clang++ ./main.cpp ./multiobj.so  -fsanitize=cfi -flto  -fvisibility=hidden -fsanitize-cfi-cross-dso -Wl,-rpath,./
/tmp/lto-llvm-176d9e.o:ld-temp.o:function main.cfi: error: undefined reference to 'directcallinso()'
/tmp/lto-llvm-176d9e.o:ld-temp.o:function class1_inso::class1_inso(): error: undefined reference to 'vtable for class1_inso'
/usr/bin/ld: the vtable symbol may be undefined because the class is missing its key function
clang-9: error: linker command failed with exit code 1 (use -v to see invocation)
➜  testspace
```

we failed! 





How can I get it over?